//+------------------------------------------------------------------+
//|                                                 Dollar Index.mq4 |
//|                                  Copyright  2009, Andy Thompson |
//|                                   mailto:andydoc1@googlemail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Andy Thompson"
#property link      "mailto:andydoc1@googlemail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_width1 2
#property indicator_color2 Yellow
#property indicator_width2 1
#property indicator_style2 1
#property indicator_color3 Lime
#property indicator_width3 1
#property indicator_style3 2

extern bool   alertsOn          = false;    // Turn alerts on
extern bool   alertsOnCurrent   = true;     // Alerts on currnt (still opened) bar
extern bool   alertsMessage     = true;     // Aleert should show pop-up message
extern bool   alertsSound       = false;    // Alerts should play alert sound
extern bool   alertsPushNotif   = false;    // Alerts should send push notification
extern bool   alertsEmail       = false;    // Alerts should send email
extern bool   arrowsVisible       = false;
extern color  arrowsUpSignalColor = LimeGreen;
extern color  arrowsDnSignalColor = Red;
extern int    arrowsUpSignalCode  = 119;
extern int    arrowsDnSignalCode  = 119;
extern int    arrowsUpSignalSize  = 2;
extern int    arrowsDnSignalSize  = 2;
extern double arrowsUpSignalGap   = 0.5;
extern double arrowsDnSignalGap   = 0.5;
extern string arrowsUniqueID      = "USDXArrows";

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double cross[];

extern int short_term_SMA_period =20;
extern int long_term_SMA_period =40;

//int winind;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel(0,"DXY");
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(1,short_term_SMA_period+"SMA");
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexLabel(2,long_term_SMA_period+"SMA");   
   SetIndexBuffer(3,cross);
   IndicatorShortName("Dollar Index: DXY / "+short_term_SMA_period+"SMA / "+long_term_SMA_period+"SMA");
// winind = WindowFind("Dollar Index: DXY / "+short_term_SMA_period+"SMA / "+long_term_SMA_period+"SMA"); 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
{  
   string lookFor       = arrowsUniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
  //---- main loop
     for(i=limit; i>=0; i--)
       {
        ExtMapBuffer1[i]=50.14348112 * MathPow(iClose("EURUSD",0,i),-0.576) * MathPow(iClose("USDJPY",0,i),0.136) * MathPow(iClose("GBPUSD",0,i),-0.119) * MathPow(iClose("USDCAD",0,i),0.091) * MathPow(iClose("USDSEK",0,i),0.042) * MathPow(iClose("USDCHF",0,i),0.036);
        ExtMapBuffer2[i]=0;
        ExtMapBuffer3[i]=0;
        for(int z=0; z<long_term_SMA_period; z++)
          {       
           if(z<short_term_SMA_period) ExtMapBuffer2[i]=ExtMapBuffer2[i]+ExtMapBuffer1[i+z];
           ExtMapBuffer3[i]=ExtMapBuffer3[i]+ExtMapBuffer1[i+z];  
          }
        ExtMapBuffer2[i] = ExtMapBuffer2[i]/short_term_SMA_period;
        ExtMapBuffer3[i] = ExtMapBuffer3[i]/long_term_SMA_period;
        cross[i] = cross[i+1];
            if (ExtMapBuffer1[i]>ExtMapBuffer2[i]) cross[i] =  1;
            if (ExtMapBuffer1[i]<ExtMapBuffer2[i]) cross[i] = -1;
            manageArrow(i);
       } 
  //---- done
   manageAlerts();
     return(0);
  }
//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (cross[whichBar] != cross[whichBar+1])
      {
         if (cross[whichBar] ==  1) doAlert(whichBar,"up");
         if (cross[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" USDX crossed sma "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(Symbol()+" USDX ",message);
          if (alertsPushNotif) SendNotification(message);
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsUniqueID+":"+Time[i]);
         if (cross[i] != cross[i+1] && cross[i]== 1) drawArrow(i,arrowsUpSignalColor,arrowsUpSignalCode,arrowsUpSignalSize,false);
         if (cross[i] != cross[i+1] && cross[i]==-1) drawArrow(i,arrowsDnSignalColor,arrowsDnSignalCode,arrowsDnSignalSize,true);
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theSize, bool tup)
{
   string name = arrowsUniqueID+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode );
         ObjectSet(name,OBJPROP_COLOR,    theColor);
         ObjectSet(name,OBJPROP_WIDTH,    theSize );      
         
         if (tup)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDnSignalGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1, Low[i] - arrowsUpSignalGap * gap);
}
